String
	var
		text

	proc

		Replace(find,replace)
			// Using an old, but very sneaky method of replacement.
			var
				list/find_list = Split(find)
				final_text = Join(find_list,replace)
			return final_text

		Remove(index,length)
			if(index > length(src.text))
				index = length(src.text)
				length = 1
			if(index <= 0) index = 1
			if(length < 0) length = 2
			if(length == 1) length = 2
			if(index+length > length(src.text))
				return src.text
			var
				cur_text = src.text
				final_string
				maxstuff = index+length
			for(var/i=1,i<length(src.text),i++)
				if(i >= index && i < maxstuff-1) continue
				else final_string += copytext(cur_text,i,i+1)
			return final_string

		Insert(string,index)
			if(!index) index = 1
			if(index <= 1)
				return "[string][text]"
			else
				if(index > length(text)) index = length(text)
				if(index == length(text))
					return "[text][string]"
				else
					var
						cur_string = text
						start_string = copytext(cur_string,1,index)
						end_string = copytext(cur_string,index)
					return "[start_string][string][end_string]"

		Trim()
			var
				leading_character = copytext(text,1,2)
				ending_character = copytext(text,length(text),length(text)+1)
				r_text = text
			while(leading_character == " ")
				r_text = copytext(r_text,2)
				leading_character = copytext(r_text,1,2)

			while(ending_character == " ")
				r_text = copytext(r_text,1,length(r_text))
				ending_character = copytext(r_text,length(r_text),length(r_text)+1)
			return r_text

		LTrim()
			var
				left_character = copytext(text,1,2)
				r_text = text
			while(left_character == " ")
				r_text = copytext(r_text,2)
				left_character = copytext(r_text,1,2)
			return r_text

		RTrim()
			var
				right_character = copytext(text,length(text),length(text)+1)
				r_text = text
			while(right_character == " ")
				r_text = copytext(r_text,1,length(r_text))
				right_character = copytext(r_text,length(r_text))
			return r_text

		Strip() return Replace(" ","")

		Join(list/list,delimiter)
			var
				final_text
				iter = 1
			for(var/E in list)
				if(iter > 1) final_text += "[delimiter]"
				final_text += E
				iter++
			return final_text

		Split(character)
			var
				cur_text = src.text
				last_found = 1
				found_char = findtext(cur_text,character)
				list/list = list()
			if(found_char)
				var/fs = copytext(cur_text,last_found,found_char)
				list += fs
				last_found = found_char+length(character)
				found_char = findtext(cur_text,character,last_found)
			while(found_char)
				var
					found_string = copytext(cur_text,last_found,found_char)
				last_found = found_char+length(character)
				list += found_string
				found_char = findtext(cur_text,character,last_found)
			list += copytext(cur_text,last_found,length(cur_text)+1)
			return list

		// For consistancy-sake.
		Explode(delimiter) return Split(delimiter)
		Implode(list/list,character) return Join(list,character)


	New(initial_string)
		text = initial_string


string
	parent_type = /String

