/*
String Handler 1.0
	By Nadrew
	Started: 01/30/2009

This library provides various functions for handling strings with BYOND.
There are two methods of accessing these functions.
	Either by the global str_ function set.
	Or by creating a new /String (or /string) datum and munipulating that.
	The global str_ functions are more friendly to BYOND-syntax.
	While the /String datum is more friendly to languages such as Python or C# which make strings objects.

*/


/* The functions are as follows:

Explode(delimiter) alias of Split()

Implode(list,character) alias of Join()

Insert(string,index) inserts a string into another string at the given index.

Join(list,delimter) returns a string of delimited text based on the passed list and delimiter.

LTrim() trims all left-hand whitespace from the string.

RTrim() trims all right-hand whitespace from the string.

Remove(index,length) remove characters from a string based on the starting position and cutting length.

Replace(find,replace) replaces one string with another inside of the parent string.

Split(delimiter) splits a string into a list based on the delimiter.

Strip() removes all spaces from the string.

Trim() trims all whitespace from the beginning and the end of the string.


Global non string datum functions are similar but have str_ prepended.
*/

/*

***** TODO *****
More commenting
****************

*/